<template>
  <b-container class="ct-workingtimes">
    
    <div id="clock-button">
      <b-button
        :variant="getVariants()"
        @click="
          changeStatus();
          postClock();
          getClock();
          updateComponent();
        "
        id="clockin"
      >
        <b-icon icon="clock-history" aria-hidden="true"></b-icon>
        {{ getVariant() }}
      </b-button>
    </div>
    <div class="time" v-for="value in info" :key="value.status">
      <p v-if="value.status === true" id="time">
        {{ formattedElapsedTimes(value) }}
      </p>
      <p v-if="value.status === true">{{ formattedElapsedTime }}</p>
    </div>
  </b-container>
</template>

<script>
import axios from "axios";
import { getUserId } from "@/router/auth.js";
// import { getUserRole } from "@/router/auth.js";
import config from "@/Utils/config.json";
import { IconsPlugin } from "bootstrap-vue";
Vue.use(IconsPlugin);
import { BButton } from "bootstrap-vue";
import Vue from "vue";
import "bootstrap/dist/css/bootstrap.css";
import "bootstrap-vue/dist/bootstrap-vue.css";
Vue.component("b-button", BButton);
import moment from "moment";
import EventBus from "./EventBus";

export default {
  name: "Clock",
  data() {
    return {
      show: true,
      info: {},
      clicked: false,
      elapsedTime: 0,
      status: false,
      timer: undefined,
    };
  },
  computed: {
    formattedElapsedTime() {
      // var test = new Object(this.info);
      // const date = new Date(null);
      this.elapsedTime;
      // date.setSeconds(
      //   this.elapsedTime + moment(Date.now()).diff(test.time) / 1000
      // );
      return null;
    },
  },
  methods: {
    updateComponent() {
      var self = this;
      self.show = false;

      Vue.nextTick(function () {
        self.show = true;
      });
    },
    async postClock() {
        await axios
          .post(
            `${config.config.res_endpoint}api/clocks/${getUserId()}`,
            {},
            {
              headers: {
                Authorization: "Bearer " + localStorage.getItem("accesToken"),
              },
            }
          )
          .then((response) => {
            this.info = response.data;
          });
      this.elapsedTime = 0
      
    },
    changeStatus() {
      this.status = !this.status;
    },
    getVariant() {
      if (this.status === false) {
        EventBus.$emit("STOP_CLOCK", { blabla: "xd" });
        return "Clock'in";
      } else if (this.status === true) {
        return "Clock'out";
      }
    },
    getVariants() {
      if (this.status === false) {
        return "success";
      } else if (this.status === true) {
        return "danger";
      }
    },
    async getClock() {
      await axios.get(
        `${config.config.res_endpoint}api/clocks/${getUserId()}`,
        {
          headers: {
            Authorization: "Bearer " + localStorage.getItem("accesToken"),
          },
        }
      );
    },
    getTime(time) {
      return moment(time).format("YYYY-MM-DD HH:mm:ss");
    },
    formattedElapsedTimes: function (test) {
      const secs = moment(Date.now()).diff(test.time) / 1000 - 3600;
      const final = moment.utc(secs * 1000).format("HH:mm:ss");
      return final;
    },
  },
  mounted() {
    axios
      .get(`${config.config.res_endpoint}api/clocks/${getUserId()}`, {
        headers: {
          Authorization: "Bearer " + localStorage.getItem("accesToken"),
        },
      })
      .then((response) => {
        this.info = response.data.data;
        var tmp = response.data.data;
        this.status = tmp[0].status;
      });
    this.timer = setInterval(() => {
      this.elapsedTime += 1000;
    }, 1000);
  },
};
</script>

<style>
@import url("https://fonts.googleapis.com/css?family=Share+Tech+Mono");

.time {
  font-family: "Share Tech Mono", sans-serif;
  font-size: 30px;
}

#time {
  margin-bottom: -22px;
}

#clockin {
  width: 50%;
  height: 100px;
}
</style>